<?php
/*
Plugin Name: WP-LinkCheck
Plugin URI: http://wordpress.org/extend/plugins/wp-linkcheck/
Description: WP-LinkCheck is a lightweight plugin ability to check all image sources are broken inside your WordPress blog.
Author: TatMing
Version: 1.0.2
Author URI: http://blog.miawork.com/

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

//error_reporting(E_ALL);
//ini_set("display_errors",1);
if (!isset($_SESSION)) { session_start(); }

require_once(ABSPATH . 'wp-config.php');
require_once(ABSPATH . 'wp-admin/includes/admin.php');
require_once(ABSPATH . 'wp-includes/functions.php');
require_once(ABSPATH . 'wp-content/plugins/wp-linkcheck/function/common.php');

add_action('admin_menu','LC_addtoolmenu');
//add_action('admin_init', 'LC_init_jquery');
add_action('admin_init','LC_processform');
global $table_prefix;
$_SESSION['ABSPATH'] = ABSPATH;
$_SESSION['is_admin'] = is_admin();
$_SESSION['table_prefix'] = $table_prefix;
$_SESSION['DB_HOST'] = DB_HOST;
$_SESSION['DB_USER'] = DB_USER;
$_SESSION['DB_PASSWORD'] = DB_PASSWORD;
$_SESSION['DB_NAME'] = DB_NAME;

if (!isset($_GET['action']))
{
	if(isset($_SESSION['datatable'])) {
		session_unset($_SESSION['datatable']); 
	}
}

function LC_processform() {
  if ($_SERVER['REQUEST_METHOD'] == 'POST' && $_POST['step1']) {
    echo $_SERVER['REQUEST_METHOD'];
  }
}

function LC_funcshowmain() {
  echo LC_loadcss();
  echo LC_loadscript();
  //Get Options
  $AryOptions = LC_funcgetoptions();
  $title = 'WP-LinkCheck';
  $blogurl = get_bloginfo('url');
  $_SESSION["blogurl"] = $blogurl;
  $intimage_checked = '';
  if (isset($_GET['type']))
  {
  	$intimage_checked = ($_GET['type']=='allimage'?'checked':'');
  } 
print <<<HEADERSCRIPT
	<!--<script type='text/javascript' src='http://getfirebug.com/releases/lite/1.2/firebug-lite-compressed.js'></script>-->
    <script type="text/javascript">
    	$.getScript(window.location.protocol + '//' + window.location.hostname + '/wp-content/plugins/wp-linkcheck/' + 'js/headerscript.js');
    </script>
HEADERSCRIPT;

print <<<OPENDIV
<div id="icon-link-manager" class="icon32"></div><h2>$title</h2>
OPENDIV;

echo "<code>System Info :</code>&nbsp;";
echo "PHP version : ".LC_checkphpver().'&nbsp;&nbsp;';
echo "cURL Module : ".LC_funcloadcurl().'&nbsp;&nbsp;';
echo "<hr />"; 

print <<<STEP1
  <form id='form1' name='form1' method="post">
    <input name='step1' type='hidden' value='true' />
    <div id='step1'>
       <strong>Step 1 :</strong><br />
       Select the check type and press 'Analyze' below, it will find out all images link inside your blog.<br />
       <input type="radio" value='image' name="radchecktype"/>Images
       &nbsp;<input type="checkbox" id="intimage" $intimage_checked />Check with internal link ($blogurl/*)
       <input type="radio" value='' name="radchecktype" style="display:none;"/>
       <input id="btnselecttype" type="button" value="Analyze" class="button-secondary action" style="width:80px" onclick="analyze();" />
    </div>
  </form>
<br />
STEP1;

print <<<STEP2
  <form id='form2' name='form2' method="post">
    <strong>Step 2 :</strong><br />
    <input name='step2' type='hidden' value='true' />
    <div id='info'>
        <div id="divTotal">Image links found : <label id="lblTotal">0</label></div>
        <div id="divDone">Checked : <label id="lblDone">0</label></div>
        <div id="divPrint" class="update-message"></div>
        <table style='border:none;'>
          <tr>
            <td>
              <div id="progressbar" style="width: 580px;"></div>
            </td>
            <td>
              <input id="btnStart" type="button" value="Start" class="button-secondary action" style="width:80px" onclick="$('#lblDone').text('0');$('#divPrint').html('0% Complete.');run('');" />
            </td>
          </tr>
		</table>
        <div style="width:1047px;">
			<div class="grid-header" style="width:100%">
				<label style='color:#666'>Pending</label>
                <span style="float:right" class="ui-icon ui-icon-search" title="Toggle search panel" onclick="toggleFilterRow()"></span>
			</div>
            <div id="inlineFilterPanel" style="display:none;background:#dddddd;padding:3px;color:black;">
                Show tasks with title including <input type="text" id="txtSearch" />
            </div>
			<div id="myGrid" style="width:100%;height:500px;"></div>
            <div id="pager" style="width:100%;height:20px;"></div>
		</div>
    </div>
    
    <input id="currpage" type="hidden" value="1"/>
  </form>
STEP2;

print <<<CLOSEDIV
</div>
CLOSEDIV;

print <<<FOOTERSCRIPT
   <script type="text/javascript">
   	$.getScript(window.location.protocol + '//' + window.location.hostname + '/wp-content/plugins/wp-linkcheck/' + 'js/footerscript.js');
   </script>
FOOTERSCRIPT;
}
?>